/*
 * BarCodePicker.java
 *
 * Created on March 2, 2000, 1:17 PM
 */
 
package demo;

import java.awt.*;
import java.awt.Toolkit.*;
import java.awt.event.*;
import java.awt.Image;
import java.beans.*;
import dsx.JBarCodePro1.*;


public class BarCodePicker  extends  Frame {





static String SymbolName[]={
    "Code 11",
	"Codabar",
	"MSI Code",
	"Code 39",
	"Extended Code 39",
	"Code 93",
	"Code 128",
	"EAN 128",
	"UPC A",
	"UPC E",
	"EAN 13",
	"EAN 8",
	"JAN 13",
	"JAN 8",
	"HIBC LIC  39",
	"HIBC LIC 128",
	"HIBC EAN/UCC128",
	"HIBC EAN/UCC25",
	"Interleaved 2 of 5"
	};
  /** Creates new form BarCodePicker */
  public BarCodePicker() {





    bfirsttime=true;

	barCodeBean1 = new dsx.JBarCodePro1.BarCodeBean ();
	
	barCodeBean1.addPropertyChangeListener(new PropertyChangeListener()

	{
	  
	   public void propertyChange(PropertyChangeEvent evt)
	   {
		  BeanPropertyChanged(evt);	
	
	   }
	}
	);

    jPanel2 = new Panel ();
    jSymbolLabel = new Label ("",Label.RIGHT);
    jSymbolCombo = new Choice ();
	jUnitLabel =new Label ("",Label.RIGHT);
	jUnitCombo =new Choice();

    jRotationLabel = new Label ("",Label.RIGHT);
    jRotationCombo = new Choice ();
    jComAlignLabel = new Label ("",Label.RIGHT);
    jAlignCombo = new Choice ();
    jBorderLabel = new Label ("",Label.RIGHT);
    jBorderCombo = new Choice ();
    jMessageLabel = new Label ("",Label.RIGHT);
    jMessageField = new TextField ();
	jSuppleLabel = new Label("",Label.RIGHT);
	jSuppleField = new TextField();
    jNarrowLabel = new Label ("",Label.RIGHT);
    jNarrowField = new TextField ();
	jQZoneLabel=new Label("",Label.RIGHT);
	jQZoneField= new TextField ();
    jHeightLabel = new Label ("",Label.RIGHT);
    jHeightField = new TextField ();
	jRatioLabel = new Label("", Label.RIGHT);
	jRatioField= new TextField ();
	jTransparentCheckBox=new Checkbox("Transparent");
	jCheckDigitsCheckBox=new Checkbox("Check Digits Enabled");
	jHRDisplayCheckBox=new Checkbox("HR Display");
	jBearerCheckBox=new Checkbox("Bearer Mode");
	jHRFontButton = new Button ();
	jTopFontButton =new Button ();
	jBottomFontButton =new Button ();
	jBGColorButton = new Button ();
	jBarColorButton =new Button ();

	jTopCommentArea=new TextArea();
	jBottomCommentArea=new TextArea();
	j128TypeLabel=new Label("",Label.RIGHT);
	j128Combo=new Choice();

    jPrint = new Button ();
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        exitForm (evt);
      }
    }
    );

    barCodeBean1.setBarHRFont (new java.awt.Font ("Arial", 0, 12));
	
    Panel pfff=new Panel();
	pfff.add(barCodeBean1);
    add (pfff, java.awt.BorderLayout.CENTER);
 //    add(barCodeBean1,java.awt.BorderLayout.CENTER);

    jPanel2.setLayout (new java.awt.GridLayout (6, 9));

  // init barcode data

    barCodeBean1.setBarBottomCommentFont (new java.awt.Font ("Arial", 0, 14));
    barCodeBean1.setBarTopCommentFont (new java.awt.Font ("Arial", 0, 14));
    barCodeBean1.setBarBottomComment ("Bottom Message\nAnother");
    barCodeBean1.setBarTopComment ("Top Comment");
    barCodeBean1.setBarHRFont (new java.awt.Font ("Arial", 0, 12));
    barCodeBean1.setBarMessage ("12345678");
	barCodeBean1.setBarHRFont(new java.awt.Font ("Arial", 0, 12));
	barCodeBean1.setBackground(Color.white);
	barCodeBean1.setForeground(Color.black);

    jSymbolLabel.setText ("Symbology ");

	for(int i=0;i<SymbolName.length;i++)
		jSymbolCombo.addItem( SymbolName[i]);
    
	jSymbolCombo.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
				Choice cb=(Choice)e.getSource();
				int isec=cb.getSelectedIndex();
				barCodeBean1.setBarSymbology(isec);
				validate();
		}
	}
	);  

   jPanel2.add (jSymbolLabel);
	jPanel2.add (jSymbolCombo);

  j128TypeLabel.setText ("128 Sets ");
  j128Combo.addItem("128 Set A");
  j128Combo.addItem("128 Set B");
  j128Combo.addItem("128 Set C");
  j128Combo.addItem("Auto Select");


	int isym=barCodeBean1.getBarSymbology();
	if(isym==barCodeBean1.BAR128||isym==barCodeBean1.BAREAN128||
		isym==barCodeBean1.BARHIBCLIC128||isym==barCodeBean1.BARHIBCEAN128)
	{
		// enable 128 set selections
		j128Combo.setEnabled(true);
	}
	else
	{
		// disable 128 set selections
		j128Combo.setEnabled(false);
	}

    
	j128Combo.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
				Choice cb=(Choice)e.getSource();
				int isec=cb.getSelectedIndex();
				barCodeBean1.setBar128Type(isec);
				validate();
		}
	}
	);  
   jPanel2.add (j128TypeLabel);
	jPanel2.add (j128Combo);

	
	Panel jparpanel=new Panel();
	jparpanel.setLayout (new java.awt.BorderLayout ()); 
	jparpanel.add(jPanel2,java.awt.BorderLayout.CENTER);

	Panel jcommentpanel=new Panel();
	jcommentpanel.setLayout(new java.awt.GridLayout(1,2));

	Panel jtopcommentpanel=new Panel();
	Panel jbottomcommentpanel=new Panel();
	jtopcommentpanel.setLayout(new java.awt.BorderLayout ()); 
	jbottomcommentpanel.setLayout(new java.awt.BorderLayout ()); 

	// top comment
	jTopCommentArea.setText(barCodeBean1.getBarTopComment());
	jTopCommentArea.setRows(3);

	/*
	Button topsetbutton=new Button("Set");
	jtopcommentpanel.add(topsetbutton,java.awt.BorderLayout.SOUTH);
	*/  
   
	jtopcommentpanel.add(jTopCommentArea,java.awt.BorderLayout.CENTER);
	

	 jTopCommentArea.addKeyListener (new java.awt.event.KeyAdapter () 
	  {
			public void keyReleased (java.awt.event.KeyEvent evt) 
			{
				barCodeBean1.setBarTopComment(jTopCommentArea.getText());
				validate();
			}
		}
	  );

  // bottom
	jBottomCommentArea.setText(barCodeBean1.getBarBottomComment());
	jBottomCommentArea.setRows(3);
	/*
	 Button bottomsetbutton=new Button("Set");
	jbottomcommentpanel.add(bottomsetbutton,java.awt.BorderLayout.SOUTH);
    */

	jbottomcommentpanel.add(jBottomCommentArea,java.awt.BorderLayout.CENTER);
	jBottomCommentArea.addKeyListener (new java.awt.event.KeyAdapter () 
	  {
			public void keyReleased (java.awt.event.KeyEvent evt) 
			{
				barCodeBean1.setBarBottomComment(jBottomCommentArea.getText());
				validate();
			}
		}
	  );

	jcommentpanel.add(jtopcommentpanel);
	jcommentpanel.add(jbottomcommentpanel);
    
	jparpanel.add(jcommentpanel,java.awt.BorderLayout.SOUTH);
	jparpanel.setSize(200,100);
	jPanel2.setSize(200,200);
    
 

 
  
     jComAlignLabel.setText ("Comment Align ");
	 jPanel2.add ( jComAlignLabel);
    
	 jAlignCombo.addItem("Center");
	 jAlignCombo.addItem("Left");
	 jAlignCombo.addItem("Right");
	 jAlignCombo.select(barCodeBean1.getBarCommentAlignStyle());

	 jAlignCombo.addItemListener (new ItemListener () {
          public void itemStateChanged (ItemEvent e) {
             Choice cb=(Choice)e.getSource();
			 int isec=cb.getSelectedIndex();
			 barCodeBean1.setBarCommentAlignStyle(isec);
          }
        }
        );  

    jPanel2.add (jAlignCombo);

     // orient
     jRotationLabel.setText ("Orientation ");
	 jPanel2.add ( jRotationLabel);
    
	 jRotationCombo.addItem("0");
	 jRotationCombo.addItem("90");
	 jRotationCombo.addItem("180");
	 jRotationCombo.addItem("270");

	 jRotationCombo.select(barCodeBean1.getBarOrientation());

	 jRotationCombo.addItemListener (new ItemListener () {
          public void itemStateChanged (ItemEvent e) {
             Choice cb=(Choice)e.getSource();
			 int isec=cb.getSelectedIndex();
			 barCodeBean1.setBarOrientation(isec*90);
          }
        }
        );  

    jPanel2.add (jRotationCombo);
    // orient above
  
        jBorderLabel.setText ("Border ");
		jPanel2.add (jBorderLabel);
    
    	jBorderCombo.addItemListener (new ItemListener () {
          public void itemStateChanged (ItemEvent e) {
             Choice cb=(Choice)e.getSource();
			 int isec=cb.getSelectedIndex();
			 barCodeBean1.setBarBorderStyle(isec);
			 validate();

          }
        }
        ); 
		
		jBorderCombo.addItem("None");	     
		jBorderCombo.addItem("Narrow broken lines");
		jBorderCombo.addItem("Wide broken lines");
		jBorderCombo.addItem("Narrow solid lines");
		jBorderCombo.addItem("Wide solid lines");
		jBorderCombo.select(barCodeBean1.getBarBorderStyle());

		jPanel2.add (jBorderCombo);
   
        jMessageLabel.setText ("Message ");
		jPanel2.add (jMessageLabel);
    
        jMessageField.setText (barCodeBean1.getBarMessage());

        jMessageField.addKeyListener (new java.awt.event.KeyAdapter () {
          public void keyReleased (java.awt.event.KeyEvent evt) {
				TextField jtmpfield=(TextField)evt.getSource();
				String s=jtmpfield.getText();
				barCodeBean1.setBarMessage(s);
			    validate();

				if(bfirsttime)
				{
				    bfirsttime=false;
				    displayMsg();
				}

          }
        }
        );       
    
		jPanel2.add (jMessageField);


		// add supplement
		jSuppleLabel.setText("Supplement ");
		jPanel2.add(jSuppleLabel);

		jSuppleField.setText(barCodeBean1.getBarSupplement());

		jSuppleField.addKeyListener (new java.awt.event.KeyAdapter () {
          public void keyReleased (java.awt.event.KeyEvent evt) {
				TextField jtmpfield=(TextField)evt.getSource();
				String s=jtmpfield.getText();
				barCodeBean1.setBarSupplement(s);
				validate();

          }
        }
        );  
		jPanel2.add(jSuppleField);  
		
		  

		jNarrowLabel.setText ("Narrow Width ");
		jPanel2.add (jNarrowLabel);
        jNarrowField.setText ((new Integer(barCodeBean1.getBarNarrowWidth())).toString());

		jNarrowField.addKeyListener (new java.awt.event.KeyAdapter () {
          public void keyReleased (java.awt.event.ActionEvent evt) {
				TextField jtmpfield=(TextField)evt.getSource();
				String s=jtmpfield.getText();
				 short shno=0;
				try
				{
				  shno=(short)Integer.parseInt(s);
				}
				catch(NumberFormatException e)
				{
				}
				
				barCodeBean1.setBarNarrowWidth(shno);
				validate();

          }
        }
        );     
        jPanel2.add (jNarrowField);

         // add quietzone
		jQZoneLabel.setText ("Quiet Zone ");
		jPanel2.add (jQZoneLabel);
        jQZoneField.setText ((new Integer(barCodeBean1.getBarQuietZone())).toString());

		jQZoneField.addKeyListener (new java.awt.event.KeyAdapter () {
          public void keyReleased (java.awt.event.KeyEvent evt) {
				TextField jtmpfield=(TextField)evt.getSource();
				String s=jtmpfield.getText();
				short shno=0;
				try
				{
				  shno=(short)Integer.parseInt(s);
				}
				catch(NumberFormatException e)
				{
				}
				barCodeBean1.setBarQuietZone(shno);
				validate();

          }
        }
        );     
        jPanel2.add (jQZoneField);


        jHeightLabel.setText ("Height ");
		jPanel2.add (jHeightLabel);
        jHeightField.setText ((new Integer(barCodeBean1.getBarHeight())).toString());

  		jHeightField.addKeyListener (new java.awt.event.KeyAdapter () {
          public void keyReleased (java.awt.event.KeyEvent evt) {
				TextField jtmpfield=(TextField)evt.getSource();
				String s=jtmpfield.getText();
				short shno=0;
				try
				{
				  shno=(short)Integer.parseInt(s);
				}
				catch(NumberFormatException e)
				{
				}
				barCodeBean1.setBarHeight(shno);
				validate();

          }
        }
        );       
    
		  jPanel2.add (jHeightField);

		  // Ration
		  jRatioLabel.setText ("Ratio ");
		  jPanel2.add (jRatioLabel);
		   jRatioField.setText ((new Float(barCodeBean1.getBarRatio())).toString());

  			jRatioField.addKeyListener (new java.awt.event.KeyAdapter () {
			  public void keyReleased (java.awt.event.KeyEvent evt) {
					TextField jtmpfield=(TextField)evt.getSource();
					String s=jtmpfield.getText();
				//Integer i=new Integer();
				
				float fno=(float)0.0;
				try
				{
				  fno=(Float.valueOf(s)).floatValue();
				}
				catch(NumberFormatException e)
				{
				}

				barCodeBean1.setBarRatio(fno);
				validate();

			  }
			}
			);       
    
		jPanel2.add (jRatioField);


       
	   // bgcolor      jbutton
	  jBGColorButton.setLabel("Background Color");
	  jPanel2.add(jBGColorButton);
	  jBGColorButton.addActionListener (new java.awt.event.ActionListener () 
	  {
			public void actionPerformed (java.awt.event.ActionEvent evt) 
			{
				Color clr=choseColor(barCodeBean1.getBackground());
				if(clr!=null)
					barCodeBean1.setBackground(clr);
			}
		}
	  );

	// barcolor     jbutton
	   jBarColorButton.setLabel("Foreground Color");

	  jBarColorButton.addActionListener (new java.awt.event.ActionListener () 
	  {
			public void actionPerformed (java.awt.event.ActionEvent evt) 
			{
				Color clr=choseColor(barCodeBean1.getForeground());
				if(clr!=null)
					barCodeBean1.setForeground(clr);
			}
		}
	  );

	   jPanel2.add(jBarColorButton);
      
	  // bearermode
	  jBearerCheckBox.setState(barCodeBean1.getBarBearerMode());
	  jPanel2.add(jBearerCheckBox);

	  jBearerCheckBox.addItemListener(new ItemListener ()
	  {
	      public void itemStateChanged(ItemEvent e)
		  {
		      handleCheckBox(e);
		  }   
	  }
	  );


      // transparency 
	  jTransparentCheckBox.setState(barCodeBean1.getBarTransparent());
	  jPanel2.add(jTransparentCheckBox);

	  jTransparentCheckBox.addItemListener(new ItemListener ()
	  {
	      public void itemStateChanged(ItemEvent e)
		  {
		      handleCheckBox(e);
		  }   
	  }
	  );

	  // check digits
	  jCheckDigitsCheckBox.setState(barCodeBean1.getBarCheckEnable());
	  jPanel2.add(jCheckDigitsCheckBox);

	  jCheckDigitsCheckBox.addItemListener(new ItemListener ()
	  {
	      public void itemStateChanged(ItemEvent e)
		  {
		      handleCheckBox(e);
		  }   
	  }
	  );

	  // HR display
	  jHRDisplayCheckBox.setState(barCodeBean1.getBarHRDisplay());
	  jPanel2.add(jHRDisplayCheckBox);

	  jHRDisplayCheckBox.addItemListener(new ItemListener ()
	  {
	      public void itemStateChanged(ItemEvent e)
		  {
		      handleCheckBox(e);
		  }   
	  }
	  );

	  
	   // HR Font      font box
	   jHRFontButton.setLabel("HR Font");

	  jHRFontButton.addActionListener (new java.awt.event.ActionListener () 
	  {
			public void actionPerformed (java.awt.event.ActionEvent evt) 
			{
				Font fn=choseFont(barCodeBean1.getBarHRFont());
				if(fn!=null)
				{
					barCodeBean1.setBarHRFont(fn);
					validate();
				}
			}
		}
	  );

	   jPanel2.add(jHRFontButton);

	 
	   // Top comment Font  font box
	   jTopFontButton.setLabel("Top Comment Font");

	  jTopFontButton.addActionListener (new java.awt.event.ActionListener () 
	  {
			public void actionPerformed (java.awt.event.ActionEvent evt) 
			{
				Font fn=choseFont(barCodeBean1.getBarTopCommentFont());
				if(fn!=null)
				{
					barCodeBean1.setBarTopCommentFont(fn);
					validate();
				}
			}
		}
	  );


	   jPanel2.add(jTopFontButton);
	   // add to TopFontBox
//	   jPanel2.add(jTopFontCombo);
	   // bottom Font  font box
	   jBottomFontButton.setLabel("Bottom Comment Font");

	  jBottomFontButton.addActionListener (new java.awt.event.ActionListener () 
	  {
			public void actionPerformed (java.awt.event.ActionEvent evt) 
			{
				Font fn=choseFont(barCodeBean1.getBarBottomCommentFont());
				if(fn!=null)
				{
					barCodeBean1.setBarBottomCommentFont(fn);
					validate();
				}
			}
		}
	  );

	   jPanel2.add(jBottomFontButton);

	   // add to BottomFontBox
	   //jPanel2.add(jBottomFontCombo);

    add (jparpanel, java.awt.BorderLayout.SOUTH);

    jPrint.setLabel ("Print");
    jPrint.setActionCommand ("jPrint");
    jPrint.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        print();
      }
    }
    );

	Button jSaveToFile =new Button();
	jSaveToFile.setLabel ("Save As PNG file");
    jSaveToFile.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
	     SaveActionPerformed(evt);
	
      }
    }
    );

	Panel jTop=new Panel();
	jTop.add(jPrint);
	jTop.add(jSaveToFile);

    add (jTop, java.awt.BorderLayout.NORTH);

    pack ();
  }

  private void displayMsg()
  {
     	MsgDialog dlg=new MsgDialog(this);
		dlg.setLocation(new Point(200,200));
		dlg.show();
  }

  // print the barcode
  private void print() 
  {

        PrintJob pj = Toolkit.getDefaultToolkit().getPrintJob(this, 
			"Printing BarCode", null);

    	if (pj != null)
		{
	    	Graphics g;
		    Dimension pageDim = pj.getPageDimension();
		    int pageRes = pj.getPageResolution();
		    boolean lastFirst = pj.lastPageFirst();

		    Graphics gr  = pj.getGraphics();
		    if (gr!=null) 
			{
		
				Point o = barCodeBean1.getLocation();
				barCodeBean1.paintBar(gr,o);
			}
			else 
				System.err.println("Could not get Graphics handle.");
			     
		    gr.dispose();
	        pj.end();

    	} 
		else 
		{
	    	 System.err.println("PrintJob cancelled.");
	    }    
  }


  protected void BeanPropertyChanged(PropertyChangeEvent evt)
  {
		 String sname=evt.getPropertyName();
		 if(sname.equals("BarHeight"))
		     jHeightField.setText((new Integer(barCodeBean1.getBarHeight())).toString());
		 else if(sname.equals("BarNarrowWidth"))
		     jNarrowField.setText((new Integer(barCodeBean1.getBarNarrowWidth())).toString());
		 else if(sname.equals("BarQuietZone"))
		 {
		     jQZoneField.setText((new Integer(barCodeBean1.getBarQuietZone())).toString());
		 }
		 else if(sname.equals("BarMessage"))
		 {
		     jMessageField.setText(barCodeBean1.getBarMessage());
		 }
		
		 else if(sname.equals("BarCheckEnable"))
		 {
			jCheckDigitsCheckBox.setState(barCodeBean1.getBarCheckEnable());		
		 }
		 else if(sname.equals("BarBearerMode"))
		 {
			jBearerCheckBox.setState(barCodeBean1.getBarBearerMode());
		 }
		 else if(sname.equals("BarSymbology"))
		 {
			int isym=barCodeBean1.getBarSymbology();
			if(isym==barCodeBean1.BAR128||isym==barCodeBean1.BAREAN128||
			isym==barCodeBean1.BARHIBCLIC128||isym==barCodeBean1.BARHIBCEAN128)
			{
			   // enable 128 set selections
				j128Combo.setEnabled(true);
			}
			else
			{
			   // disable 128 set selections
			   j128Combo.setEnabled(false);
			}
		 }
	 barCodeBean1.invalidate();
  }
  
  
  protected Color choseColor(Color iniColor)
	  {
	     ColorDialog dlg=new ColorDialog(this);
         dlg.show();
	     return dlg.mselcolor;
	  } 

  protected Font choseFont(Font iniFont)
  {
      // init our dialog for color
	  FontDialog dlg=new FontDialog(this);
	  dlg.setLocation(new Point(200,200));
	  dlg.showDialog(iniFont);
	  return dlg.newFont;

  }

  protected void handleCheckBox(ItemEvent e)
  {  
		Object source = e.getItemSelectable();
		boolean bselected=(e.getStateChange() == ItemEvent.SELECTED);
		if(source==jTransparentCheckBox)
 			barCodeBean1.setBarTransparent(bselected);
		else if(source==jCheckDigitsCheckBox)
		{
			barCodeBean1.setBarCheckEnable(bselected);
		}
		else if(source==jHRDisplayCheckBox)
		{
		    barCodeBean1.setBarHRDisplay(bselected);
		}
		else if(source==jBearerCheckBox)
			barCodeBean1.setBarBearerMode(bselected);
		validate();
  }

 
  
  private void jMessageFieldActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMessageFieldActionPerformed
// Add your handling code here:
  }//GEN-LAST:event_jMessageFieldActionPerformed

  private void jBorderComboItemStateChanged (java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jBorderComboItemStateChanged
// Add your handling code here:
  }//GEN-LAST:event_jBorderComboItemStateChanged
private void jRotationComboItemStateChanged(java.awt.event.ItemEvent evt)
  {
    int s=5;
    String stmp=(String)evt.getItem();
    }
  private void jButton1ActionPerformed (java.awt.event.ActionEvent evt) {

  }

  private void SaveActionPerformed(java.awt.event.ActionEvent evt)
  {
      FileDialog fdlg=new FileDialog(this,"Save BarCode as PNG file",FileDialog.SAVE);
	  fdlg.show();
	  String sfile=fdlg.getFile();
	  if(sfile!=null)
	  {
	    sfile=fdlg.getDirectory()+sfile;
		barCodeBean1.putPngImageToFile(sfile);
	  }
  }



  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit (0);
  }//GEN-LAST:event_exitForm

  public void SetMessage(String mes)
  {
     barCodeBean1.setBarMessage(mes);
  }
  /**
  * @param args the command line arguments
  */
  public static void main (String args[]) {
    BarCodePicker tmp=new BarCodePicker();
	tmp.setSize(780,600);
    tmp.show ();
    tmp.SetMessage("1234567890");
	tmp.validate();
    
  }

	  // Variables declaration - do not modify//GEN-BEGIN:variables
	  private dsx.JBarCodePro1.BarCodeBean barCodeBean1;
	  private Panel jPanel2;
	  private Label jSymbolLabel;
	  private Choice jSymbolCombo;
	  private Label jUnitLabel;
	  private Choice jUnitCombo;
	  private Label jRotationLabel;
	  private Choice jRotationCombo;
	  private Label jComAlignLabel;
	  private Choice jAlignCombo;
	  private Label jBorderLabel;
	  private Choice jBorderCombo;
	  private Label jMessageLabel;
	  private TextField jMessageField;
	  private Label jSuppleLabel;
	  private TextField jSuppleField;
	  private Label jNarrowLabel;
	  private TextField jNarrowField;
	  private Label jQZoneLabel;
	  private TextField jQZoneField;
	  private Label jHeightLabel;
	  private TextField jHeightField;
	  private Label jRatioLabel;
	  private TextField jRatioField;
	  private Checkbox jTransparentCheckBox;
	  private Checkbox jCheckDigitsCheckBox;
	  private Checkbox jBearerCheckBox;
	  private Checkbox jHRDisplayCheckBox;
	  private Button jPrint;
	  // End of variables declaration//GEN-END:variables
      private Button jBGColorButton;
	  private Button jBarColorButton;
	  private Button jHRFontButton;
	  private Button jTopFontButton;
	  private Button jBottomFontButton;
	  private Label j128TypeLabel;
	  private Choice j128Combo;



	  // top comment using text area
	  private TextArea  jTopCommentArea;
	  private TextArea  jBottomCommentArea;
	  private Button jPrintBtn;

	  private boolean bfirsttime;
}

class ColorDialog extends Dialog
{
   private List jColorList;

   public Color mselcolor;
   ColorDialog(Frame frame)
   {
      super(frame,true);  // modal dialog

	   addWindowListener (new java.awt.event.WindowAdapter () {
			  public void windowClosing (java.awt.event.WindowEvent evt) {
				  setVisible(false);
				  dispose();
			  }
			}
			);
      setLocation(new Point(100,100));
	  setResizable(false);
	  jColorList=new List();
	  jColorList.addItem("black");
	  jColorList.addItem("blue");
	  jColorList.addItem("cyan");
	  jColorList.addItem("darkGray");
	  jColorList.addItem("gray");
	  jColorList.addItem("green");
	  jColorList.addItem("lightGray");
	  jColorList.addItem("magenta");
	  jColorList.addItem("orange");
	  jColorList.addItem("pink");
	  jColorList.addItem("red");
	  jColorList.addItem("white");
	  jColorList.addItem("yellow");

	  Panel pbuttons=new Panel();
	  Button okbutton=new Button("OK");
	  Button cancelbutton=new Button("CANCEL");
	  pbuttons.add(okbutton);
	  pbuttons.add(cancelbutton);

	  Panel ptop=new Panel();
	  ptop.add(new Label("Color",Label.RIGHT));
	  ptop.add(jColorList);

      add(ptop,BorderLayout.NORTH);
	  add(pbuttons,BorderLayout.CENTER);

	  // add event handler
      cancelbutton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
			  setVisible(false);
			  mselcolor=null;
			  dispose();
			 
            }
        });
     // add event handler for ok button
      okbutton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
               // ListDialog.dialog.setVisible(false);
			  setVisible(false);
			  dispose();
			  // check the list and update mselcolor
			  int idex=jColorList.getSelectedIndex();
			  switch(idex)
			  {
			      case 0:
				  mselcolor=Color.black;
				  break;
				  case 1:
				  mselcolor=Color.blue;
				  break;
				  case 2:
				  mselcolor=Color.cyan;
				  break;
				  case 3:
				  mselcolor=Color.darkGray;
				  break;
				  case 4:
				  mselcolor=Color.gray;
				  break;
				  case 5:
				  mselcolor=Color.green;
				  break;
				  case 6:
				  mselcolor=Color.lightGray;
				  break;
				  case 7:
				  mselcolor=Color.magenta;
				  break;
				  case 8:
				  mselcolor=Color.orange;
				  break;
				  case 9:
				  mselcolor=Color.pink;
				  break;
				  case 10:
				  mselcolor=Color.red;
				  break;
				  case 11:
				  mselcolor=Color.white;
				  break;
				  case 12:
				  mselcolor=Color.yellow;
				  break;
			  }
			  
            }
        });
	 pack();
   }
}

class FontDialog extends Dialog
{
    FontDialog(Frame frame)
	{
	   // init members
	   super(frame,true);
	   bcancel=false;
	   newFont=null;
	   
		jFontNameBox=new List();
		jFontStyleBox=new List();
		jFontSizeBox=new List();

		jFontPanel=new Panel();
		jFontPanel.add(jFontNameBox);
		jFontPanel.add(jFontStyleBox);
		jFontPanel.add(jFontSizeBox);

		add(jFontPanel,java.awt.BorderLayout.CENTER);

		addWindowListener (new java.awt.event.WindowAdapter () {
			  public void windowClosing (java.awt.event.WindowEvent evt) {
			  //   bcancel=true;
				setVisible(false);
			  dispose(); 
			  }
			}
			);

		FillFontList(jFontNameBox);
		// fill style
		jFontStyleBox.addItem("Plain");
		jFontStyleBox.addItem("Bold");
		jFontStyleBox.addItem("Italic");
		jFontStyleBox.addItem("BOLD and Stylic");

		// fill size
		for(int i=0;i<100;i++)
		{
			jFontSizeBox.addItem((new Integer(i)).toString());
		}

        Panel okcancelPanel= new Panel();
		add(okcancelPanel,java.awt.BorderLayout.SOUTH);

	    Button okButton = new Button("OK");
       // final JButton setButton = new JButton("Set");
        okButton.addActionListener(new ActionListener() {
			  public void actionPerformed(ActionEvent e) {
			  
			  sFamily=(String)(jFontNameBox.getSelectedItem());
			  if(sFamily==null)
			     sFamily="Dialog";
			  iStyle=jFontStyleBox.getSelectedIndex();
			  if(iStyle<0)
			    iStyle=0;
			  if(iStyle==0)
				iStyle=Font.PLAIN;
			  else if(iStyle==1)
			    iStyle=Font.BOLD;
			  else if(iStyle==2)
			    iStyle=Font.ITALIC;
			  else
			    iStyle=Font.BOLD+Font.ITALIC;
			  iSize=(Integer.decode(jFontSizeBox.getSelectedItem())).intValue();
			  newFont=new Font(sFamily,iStyle,iSize);		
			  setVisible(false);
            }
        });
		okcancelPanel.add(okButton );

		Button cancelButton = new Button("Cancel");
       // final JButton setButton = new JButton("Set");
        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
               // ListDialog.dialog.setVisible(false);
			  // dispatchEvent(new WindowEvent(this,WindowEvent.WINDOW_CLOSING));
			  setVisible(false);
			  dispose();
			 
            }
        });
		okcancelPanel.add(cancelButton);

	

		pack ();
		
		
	}

	public void showDialog(Font font)
	{
//		set selected items
        // set selected font family
		String sfontname=font.getFamily();
		int icount=jFontNameBox.getItemCount();
		for(int i=0;i<icount;i++)
		{
		
		    if(sfontname.equalsIgnoreCase((String)jFontNameBox.getItem(i))==true)
			{
				jFontNameBox.select(i);
				break;
			}
		
		}
		// set selected style
		int itmp=font.getStyle();
		int idex=-1;
		if(itmp==font.PLAIN)
			idex=0;
		else if(itmp==font.BOLD)
			idex=1;
		else if(itmp==font.ITALIC)
			idex=2;
		else if(itmp==(font.ITALIC+font.BOLD))
			idex=3;
		jFontStyleBox.select(idex);
		// set selected size
		jFontSizeBox.select(font.getSize());
		setSize(350,300);

		setVisible(true);

	}
	protected void FillFontList(List comBox)
   {
		String sfontname[]=Toolkit.getDefaultToolkit().getFontList();
		int ilen=sfontname.length;
		for(int i=0;i<ilen;i++)
		{
		  
		    jFontNameBox.addItem(sfontname[i]);
		}
   }
    private String sFamily;
	private int    iStyle;
	private int    iSize;
    private boolean bcancel;
	private List jFontNameBox;
	private List jFontStyleBox;
	private List jFontSizeBox;
	private Panel jFontPanel;
	private Panel jPreviewPanel;
	public Font newFont;
}


class MsgDialog extends Dialog
{
	MsgDialog(Frame frame)
   {
      super(frame,true);  // modal dialog
		addWindowListener (new java.awt.event.WindowAdapter () {
			  public void windowClosing (java.awt.event.WindowEvent evt) {
				  setVisible(false);
				  dispose();
			  }
			}
			);

		setTitle("JBarCodeBean1");

	   Label msg=new Label("You are using evaluation copy of JBarCodePro1. For product copy, please contact DSX or visit www.dsxtech.com");
	   add(msg,BorderLayout.CENTER);
	   pack();
	   setResizable(false);
	   
	}
}


